#pragma once

#include <curl/curl.h>

#include "global.h"
#include "exception.inl"

namespace cppcurl
{

    /* global */

    global::global()
    {
        if (counter()++ == 0)
        {
            auto err = curl_global_init(CURL_GLOBAL_DEFAULT);
            if (err != CURLE_OK)
                throw easy_exception(err, "Unable to initialize libcurl");
        }
    }

    global::~global()
    {
        if (--counter() == 0)
        {
            // TODO logging?
            curl_global_cleanup();
        }
    }

    bool global::is_initialized()
        { return static_cast<bool>(counter()); }

    int& global::counter()
    {
        static int value(0);
        return value;
    }

}
