#pragma once

#include <curl/curl.h>

namespace cppcurl
{

    namespace __impl
    {

        template<CURLINFO T_info, typename T_value>
        struct info
        {
        public:
            using value_type = T_value;

            static constexpr CURLINFO id = T_info;

        public:
            value_type value;
        };

    }

    template<CURLINFO T_info>
    struct info;

#define cppcurl_define_info(nfo, type) \
    template<> \
    struct info<nfo> \
        : public __impl::info<nfo, type> \
        { }

    cppcurl_define_info(CURLINFO_CONTENT_TYPE, std::string);
    cppcurl_define_info(CURLINFO_RESPONSE_CODE, long);

#undef cppcurl_define_info
}
