#pragma once

#include <string>
#include <vector>
#include <memory>
#include <curl/curl.h>

namespace cppcurl
{

    struct slist
    {
    private:
        using handle_ptr_u = std::unique_ptr<curl_slist, decltype(&curl_slist_free_all)>;
        using string_vector = std::vector<std::string>;

    private:
        handle_ptr_u    _handle;

    public:
        /**
         * @brief Constructor.
         */
        inline slist();

        /**
         * @brief Get the internal curl easy handle.
         */
        inline curl_slist* handle() const;

        /**
         * @brief Add string to the list.
         */
        inline void append(const std::string& s);

        /**
         * @brief clear the list.
         */
        inline void reset();
    };

}

#include "slist.inl"
