#pragma once

#include "slist.h"

namespace cppcurl
{

    /* slist */

    slist::slist()
        : _handle(nullptr, &curl_slist_free_all)
        { }

    curl_slist* slist::handle() const
        { return _handle.get(); }

    void slist::append(const std::string& s)
        { _handle.reset(curl_slist_append(_handle.release(), s.c_str())); }

    void slist::reset()
        { _handle.reset(); }

}
